# MultiSync

MultiSync est un outil permettant une synchronisation séquentielle de répertoires.

> Ce projet est largement inspiré du produit similaire développé par Alain Jeanmaire.

## Cas d'utilisation

L'outil est prévu pour la distribution au compte goutte de données d'exercice, de travaux écrits ou d'examens. Lorsqu'un enseignant désire transmettre une partie de la donnée et ne distribuer la suite que lorsque la première partie est terminée, MultiSync réalise tout seul les travaux de copie dans les deux sens.

Exemple, d'utilisations successives sur un poste donné:

- La partie 1 est distribuée
- La partie 1 est récupérée et la partie 2 distribuée
- La partie 2 est récupérée et la partie 3 distribuée
- La partie 3 est récupérée

## Mode d'emploi

### Préparation

**Attention:** cette procédure suppose que vous prenez la version "Release" de l'application. Si ce n'est pas le cas, téléchargez la [dernière version de PHP](https://windows.php.net/download) vers `bin/php` afin de pouvoir exécuter le script.

1. Placez le fichier `sync.bat` et le répertoire `bin` à la racine d'une clé USB.
2. Lancez le script `sync.bat` en double-cliquant sur l'icône.
3. Un message apparait, qui indique que le fichier `config.json` n'a pas été trouvé et qu'il se génère.
4. Remplissez le fichier `config.json` avec les deux informations suivantes:
    - `source` est le répertoire source de la donnée, situé sur la clé USB. Conseil: laissez cette valeur par défaut.
    - `destination` est le répertoire sur lequel travaillent les élèves. Il doit s'agir d'un chemin absolu sur la machine et doit être le même sur chaque poste élève.
    - **Attention: les chemins doivent soit utiliser le séparateur de répertoire slash (/), soit échapper les caractères antislash (\\\\). Les deux possibilités sont équivalentes, même sous Windows.**
5. Créez le répertoire source (par défaut `source`, situé à la racine de la clé USB).
6. Créez autant de sous-répertoires que vous avez de parties dans le fichier source. Chaque sous-répertoire doit s'appeler `partie-*`, avec un numéro indiquant de quelle partie il s'agit. Exemple du contenu de la clé USB:  
```
Z:\
|- bin
|  |- <ne pas toucher>
|- source
|  |- partie-1
|  |  |- Donnée partie 1.docx
|  |  |- data.sql
|  |  |- connect.php
|  |- partie-2
|  |  |- Donnée partie 2.docx
|  |- partie-3
|     |- Donnée partie 3.docx
|     |- ex-1.php
|     |- ex-2.php
|     |- ex-5.php
|- config.json
|- sync.bat
```
7. Si vous partagez le même exercice avec d'autres enseignants ou surveillants, votre clé est prête à être utilisée et le contenu peut être copié vers d'autres supports.

### Utilisation

1. Sur chacun des postes élèves, insérez la clé USB et lancez `sync.bat`. Trois messages apparaissent: "Création du répertoire de travail", "Création du fichier user.json" et "Distribution de la partie 1".
2. Informez les élèves qu'ils doivent remplir le fichier `user.json` situé dans le répertoire de travail en précisant leur prénom, leur nom de famille, leur classe et le numéro de leur poste.
3. Lorsqu'un élève a terminé la partie 1, insérez à nouveau la clé USB dans son ordinateur, demandez-lui de double-cliquer sur `sync.bat` et de suivre les instructions (appuyer sur une touche à la fin du processus de copie).
4. À ce moment-là, la partie 1 de l'élève aura été récupérée et placée dans le répertoire `rendu` et la partie 2 aura été distribuée.
5. Répétez le processus pour chaque élève et pour chaque partie.
6. Lorsqu'un élève a terminé la dernière partie, `sync.bat` la récupère mais ne distribue plus rien.

### Organisation des résultats

Après récupération de tous les travaux d'élèves, le répertoire `rendu` contient un sous-répertoire par classe.

Dans chaque classe, on trouve un sous-répertoire contenant le nom, prénom et numéro de machine de chaque élève.

Dans ceux-ci, on trouve une copie de leurs répertoires `partie-*`.

Exemple:

```
rendu
|- 2INF-CP-1M
|  |- Covert_Harry_LMB-310-04
|  |  |- partie-1
|  |  |  |- <réponses>
|  |  |- partie-2
|  |  |  |- <réponses>
|  |  |- partie-3
|  |     |- <réponses>
|  |- Draté_Daisy_LMB-310-12
|  |  |- partie-1
|  |  |  |- <réponses>
|  |  |- partie-2
|  |  |  |- <réponses>
|  |  |- partie-3
|  |     |- <réponses>
|  |- Tension_Manu_LMB-310-01
|     |- partie-1
|     |  |- <réponses>
|     |- partie-2
|     |  |- <réponses>
|     |- partie-3
|        |- <réponses>
|- 2INF-CP-2M
|  |- Stiqué_Sophie_LMB-310-05
|  |  |- partie-1
|  |  |  |- <réponses>
|  |  |- partie-2
|  |  |  |- <réponses>
|  |  |- partie-3
|  |     |- <réponses>
|  |- Zarella_Maude_LMB-310-08
|     |- partie-1
|     |  |- <réponses>
|     |- partie-2
|     |  |- <réponses>
|     |- partie-3
|        |- <réponses>
|- 2INF-CD-M
   |- Truand_Tony_LMB-310-09
         |- partie-1
         |  |- <réponses>
         |- partie-2
         |  |- <réponses>
         |- partie-3
            |- <réponses>
```

## Bugs et améliorations

Merci de poster toutes vos déclarations de bug ou demandes d'améliorations sur la [page "issues" du projet GitLab](https://git.s2.rpn.ch/SteeveDroz/multisync/-/issues) ou par e-mail à [sd@rpn.ch](mailto:sd@rpn.ch).

## Participation au développement

Toute proposition d'aide au développement est la bienvenue.
